C***********************************************************
C***********************************************************
C
      SUBROUTINE  ADFAL1
     I   (   QADV, IFL, 
     W       FLQZ ,
     O       DTQFAL, 
     B       DENS0, PRES0, 
     C       GRAV , QDENS, QRMOD, 
     G       DX, FDZ, FDZM,
     D       NX, NZ, NXB, NZB, NROT )
C
C***********************************************************
      IMPLICIT REAL*8 ( A-H, O-Z )
C***********************************************************
C
      DIMENSION
     \     QADV ( -2:NXB, -2:NZB, NROT ),
     \     DTQFAL( -2:NXB, -2:NZB ),
     \     FLQZ ( -2:NXB, -2:NZB )
C
      DIMENSION
     \     DENS0( -2:NZB ),
     \     PRES0( -2:NZB ),
     \     FDZ ( -2:NZB ),
     \     FDZM( -2:NZB )

      DIMENSION
     \     WFALL( -2:NXB, -2:NZB )
C
C===========================================================
C terminal velocity (Conrath, 1975, Icarus, 24, 36-46)
C
      VISCOS = 1.5D-5
      FRPATH = 2.2D-6
      PRES_R = 2.5D+3 

      DO IZ = 0, NZ-1
         DO IX = 1, NX
            WFALL(IX,IZ) = - DENS0(IZ) * 
     \           ( QDENS * GRAV * QRMOD **2 / 18.0D0 / VISCOS ) *
     \           ( 1.0D0 + 
     \             2.0D0 * FRPATH * PRES_R / QRMOD / PRES0(IZ) )
         END DO
      END DO
C
C===========================================================
C
      DO 101 IZ = 0, NZ-1
      DO 101 IX = 1, NX
C         FLQZ(IX,IZ) =   WFALL(IX,IZ) / 16.0D0
C     \  * (   9.0D0 * ( QADV(IX,IZ-1,IFL) + QADV(IX,IZ  ,IFL) )
C     \      -         ( QADV(IX,IZ-2,IFL) + QADV(IX,IZ+1,IFL) ) )

         FLQZ(IX,IZ) = WFALL(IX,IZ) * QADV(IX,IZ  ,IFL)

  101 CONTINUE

      do 102 ix = 1, nx
         flqz(ix,nz) = 0.0d0
 102  continue
C
      CALL BOUND ( FLQZ, NX, NZ, NXB, NZB, 1,-1, 0, 1 )
C
C
      DO 11 IZ = 0, NZ-1
      DO 11 IX = 1, NX
C
c         DTQFAL(IX,IZ) =
c     \     (  - 1.125D0 * ( FLQZ(IX,IZ+1) - FLQZ(IX,IZ  ) )
c     \        + 0.125D0 * ( FLQZ(IX,IZ+2) - FLQZ(IX,IZ-1) ) / 3.0D0 )
c     \    / DENS0(IZ) / FDZ(IZ) / DX
         DTQFAL(IX,IZ) = 
     \     (  - ( FLQZ(IX,IZ+1) - FLQZ(IX,IZ) ) )
     \    / DENS0(IZ) / FDZ(IZ) / DX
C
   11 CONTINUE
C
      CALL BOUND ( DTQFAL, NX, NZ, NXB, NZB, 1, 1, 1, 1 )
C
C================================================================
C
      RETURN
      E N D
