C*********************************************************************
C
C     PROGRAM xzcont_ptm_3
C
C     x-zʿ޺ץ(, )
C
C      1997/07/24 
C          1997/07/25 
C          1997/07/26 
C          1997/07/26 
C          1998/09/17 
C          1998/10/02 
C          1999/01/10 
C          1999/02/04 
C          1999/02/07 
C
C*********************************************************************
      program xzcont_ptm_3
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )

      real*8
     \   zgrid ( -2:nzb ),temp0 ( -2:nzb ),tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ),ppai0 ( -2:nzb ),pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ),
     \   qvap0 ( -2:nzb )

      real*8
     \     tpot ( -2:nxb, -2:nzb ), ttpot ( -2:nxb, -2:nzb )

      real*4
     \    z0p ( 0:nz ), p0p ( 0:nz ),    d0p ( 0:nz ),
     \ temp0p ( 0:nz ), tpot0p ( 0:nz ), pai0p ( 0:nz ),
     \ rvap0p ( 0:nz ), qvap0p ( 0:nz )

      real*4 
     \      tpotp ( nx+1, nz+1 ), tpall ( nx+1, nz+1 ),
     \      tpave ( nz+1 ),       tpdev ( nx+1, nz+1 )

      character*2 mint, lt, date
      character*17 header

*-----------------------------------------------------
      real*4 xvpt, yvpt
      real*4 tpdev_p(nz/2+1, nz/2+1)
*-----------------------------------------------------
      parameter ( nzprof = nz )                              
      parameter ( nzp = nz+1, ntp = 120 )

      character*5  nmrun
      character*4  from
      character*1  chara
      character*1  pz

      real*4  dtpad0,dqvad0
      real*4  zp(nzp)    ,tptend(nzp),tpmean(nzp),
     &        dtpadv(nzp),dtpdif(nzp),dtpdnl(nzp), 
     &        dtpdi0(nzp),dtprad(nzp),
     &        tperror(nzp),dtirad(nzp),dtsrad(nzp)

      real*4 itime(100), heat(100)
      real*4 sflux_h, tinterv

      integer fnum, begin, end, interv, nloop1

C=====================================================================  

      xvpt = 0.05
      yvpt = 0.4

      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als
      close(11)

      tinterv = nloop2 * ( dtime / 2. )

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      do iz = 0, nz
         z0p(iz)   = zgrid(iz)
         p0p(iz)   = pres0(iz)
         d0p(iz)   = dens0(iz)
         temp0p(iz)= temp0(iz)
         tpot0p(iz)= tpot0(iz)
         pai0p(iz) = ppai0(iz)
         rvap0p(iz)= rvap0(iz)
         qvap0p(iz)= qvap0(iz)
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv

      iflag = 0

      call sgpwsn
      read(*,*) iws

      call gropn(iws)
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call uzfact(0.5)
      call UDLSET( 'LMSG', .FALSE. )
*
      do it = 1, ite

      read(34) time, ((tpot(ix,iz),ix=-2,nxb), iz=-2,nzb)

      write(0,*) 'reading time = ', time

      if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time

c*** Ѵ: ä LT ************************************
            time = time + times
            write(date,'(I2.2)') INT( time / day ) + 1

            time = ( time - INT( time / day ) * day ) / hour 

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(lt, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

            header = 'day=' // date // ' ' // 'LT=' // lt // ':' // mint
c**************************************************************

!- rm 2-grid noize ----------------------------------------------------

            do iz = -2,nzb
            do ix = 0,nx
               ttpot(ix,iz) = ( tpot(ix-1,iz) + 2.0*tpot(ix,iz)
     \                        + tpot(ix+1,iz) ) / 4.0 
            end do
            end do

            do iz = -2,NZB
               ttpot(-2,iz)  = tpot(nx-2,iz) 
               ttpot(-1,iz)  = tpot(nx-1,iz) 
               ttpot(0,iz)   = tpot(nx,iz) 
               ttpot(nx+1,iz)= tpot(1,iz) 
               ttpot(nx+2,iz)= tpot(2,iz) 
            end do

            do iz = -2,nzb
            do ix = -2,nxb
               tpot(ix,iz) = ttpot(ix,iz)
            end do
            end do

!- rm 2-grid noize ----------------------------------------------------

            do iz = 1,nz+1
               do ix = 1, nx+1
                  tpotp(ix,iz) = tpot(ix-1,iz-1)
                  tpall(ix,iz) = tpot(ix-1,iz-1) + tpot0(iz-1)
               end do
            end do
*
            do iz = 1, nz+1
               tpave(iz) = 0.
               do ix = 1,nx+1
                  tpave(iz) = tpave(iz) + tpall(ix,iz) /(nx+1)
               end do
            end do

            do iz = 1,nz+1
               do ix = 1, nx+1
                  tpdev(ix,iz) = tpall(ix,iz) - tpave(iz) 
               end do
            end do

            do iz = 1,nz/2+1
               do ix = 1, nz/2+1
                  tpdev_p(ix,iz) = tpdev(ix+250,iz)
               end do
            end do

            if (iflag .eq. 4) then
               iflag = 1
               xvpt = 0.05
            else 
               iflag = iflag + 1
            end if

            if ( iflag .eq. 1 ) then
               call grfrm
            else
               call grfig
            end if

            call grswnd ( 0.0, 10.0, 0.0, 10.0 )
            call grsvpt ( xvpt, xvpt+0.2, 0.48, 0.68 )
            call grstrn (1)
            call uspfit
            call grstrf
            call udpset ( 'rsizet', 0.01 )
            call udpset ( 'ICYCLE', 2 )

            call uestlv ( -10., 0., 603)
            call uetone ( tpdev_p, nz/2+1, nz/2+1, nz/2+1 )
            call ueitlv

            if ( iflag .eq. 1 ) then
               call ussttl ( '', '', '', 'Z[km]' )
               call usdaxs
            else if ( iflag .eq. 4 ) then
c               call ussttl ( '', 'X[km]', '', '' )
               call usdaxs
            else
               call slpvpr( 3 )
               call uxaxdv( 'B', 1., 2. )
               call uxaxdv( 'T', 1., 2. )
               call uyaxdv( 'L', 1., 2. )
               call uyaxdv( 'R', 1., 2. )
            end if

            call udgcla ( -10., 10., 1. )

            call udcntz ( tpdev_p, nz/2+1, nz/2+1, nz/2+1, ibr, nbr3)
            call uxsttl ( 'T', header, 1. )
            call uzinit
*
*
            xvpt = xvpt + 0.23

         end if
      end if

      end do

      call FCLOSE

      iflag = 0
      xvpt = 0.05

      do it = 1, ite

         fnum = 50 + it
         open(fnum)

         read(fnum,'(a2,a15,g15.7,a6,g15.7,a4)') 
     &        chara, nmrun, t_begin, from, t_end,
     &        pz

         read(fnum,*) AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL

         do iz = 1, nzp-1
            read(fnum,*) zp(iz), 
     &           tperror(iz),
     &           tptend(iz),
     &           tpmean(iz),
     &           dtpadv(iz),
     &           dtpdif(iz),
     &           dtpdnl(iz),
     &           dtpad0,
     &           dtpdi0(iz),
     &           dtprad(iz),
     &           dtirad(iz),
     &           dtsrad(iz)
         end do

         close(fnum)

         do iz = 1, nzp
            zp(iz) = zp(iz) /1000.
         end do

         if ( it .ge. itb   .and.  it .le. ite ) then
            if ( mod( (it-itb), interv ) .eq. 0 ) then

         if (iflag .eq. 4) then
            iflag = 1
            xvpt = 0.05
         else 
            iflag = iflag + 1
         end if

        
         call grfig
         call grswnd( 190., 310., 0., 20. )
         call grsvpt ( xvpt, xvpt+0.2, 0.25, 0.45 )
         call grstrn(1)
         call grstrf
         call usdaxs
         call uulinz(nz, tpmean, zp, 1, 3 )

         xvpt = xvpt + 0.23

         end if
         end if
         
      end do
*
*      
      iflag = 0
      xvpt = 0.05

      call SETCST
     \     ( grav, psd, amdry, rdry, cpdry, rmvap, alatent )


      do it = 1, ite

         fnum = 50 + it
         open(fnum)

         read(fnum,'(a2,a15,g15.7,a6,g15.7,a4)') 
     &        chara, nmrun, t_begin, from, t_end,
     &        pz

         read(fnum,*) AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL

         do iz = 1, nzp-1
            read(fnum,*) zp(iz), 
     &           tperror(iz),
     &           tptend(iz),
     &           tpmean(iz),
     &           dtpadv(iz),
     &           dtpdif(iz),
     &           dtpdnl(iz),
     &           dtpad0,
     &           dtpdi0(iz),
     &           dtprad(iz),
     &           dtirad(iz),
     &           dtsrad(iz)

         end do

         close(fnum)

         do iz = 1, nzp-1
            zp(iz) = zp(iz) /1000.
         end do

         if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            if (iflag .eq. 4) then
               iflag = 1
               xvpt = 0.05
            else 
               iflag = iflag + 1
            end if

            open(13)
            read(13,*) (itime(j),j=1,nloop1),(heat(j),j=1,nloop1)
            close(13)

            begin = INT( t_begin -  INT( t_begin / day ) * day )
     \           / tinterv
            end   = INT( t_end -  INT( t_begin / day ) * day )
     \           / tinterv

            do i = 1, nloop1
               heat(i) = heat(i)/tinterv
            end do
               
            interval = end - begin + 1

            sflux_h = 0.
            do i = begin, end
               sflux_h = sflux_h + heat(i) / interval
            end do
            
            sflux_h = sflux_h / 
     \           ( cpdry * dens0(1) * z0p(1)*2 * 51200.)
            dtpdif(1) = dtpdif(1) + sflux_h
            
            do iz = 1, nzp
               dtpdif(iz) = ( dtpdif(iz) + dtpdi0(iz) )* day
               tptend(iz) = tptend(iz) * day
               dtpadv(iz) = ( dtpadv(iz) + dtpdnl(iz) )* day
               dtprad(iz) = dtprad(iz) * day
               
               if ( dtpadv(iz) .gt. 200.0 ) then
                  dtpadv(iz) = 200.0
               else if ( dtpadv(iz) .lt. -200.0 ) then
                  dtpadv(iz) = - 200.0
               end if
               
               if ( dtprad(iz) .gt. 200.0 ) then
                  dtprad(iz) = 200.0
               else if ( dtprad(iz) .lt. -200.0 ) then
                  dtprad(iz) = - 200.0
               end if

               if ( dtpdif(iz) .gt. 200.0 ) then
                  dtpdif(iz) = 200.0
               else if ( dtpdif(iz) .lt. -200.0 ) then
                  dtpdif(iz) = - 200.0
               end if
               
            end do

            call grfig
            call grswnd( -200., 200., 0., 10. )
            call grsvpt ( xvpt, xvpt+0.2, 0.02, 0.22 )
            call grstrn(1)
            call grstrf
            call uxaxdv ( 'B', 20., 100. )
            call uxaxdv ( 'T', 20., 100. )
            call usdaxs

            call uulinz(nz/2+1, dtpadv, zp, 1, 3)
c            call uulinz(nz/2+1, dtpdif, zp, 2, 3)
            call uulinz(nz/2+1, dtprad, zp, 3, 3)

            xvpt = xvpt + 0.23
               
         end if
         end if

      end do

      call grcls

      end

